#!/usr/bin/perl

require "librairie.pl";


# Here, we take the number of the line where is the rule we'll modify
# We call the subroutine 'ReadRule' witch return a string with the rule
# After that, we split the rule
# We make the same interface that for insert a new rule but there is already encoded(un truc ainsi)

use CGI;
$html = new CGI;

    
# Opening of file which we'll use to make the lists
    open(FILE, "<$ipffi1") || die "Erreur d'ouverture de $ipffi1";
    flock (FILE, 2);
    @lignes = <FILE>;
    $nbelemtab = $#lignes+1;
    flock (FILE, 8);
    close(FILE);

    open(FILE2, "<$ipffi2") || die "Erreur d'ouverture de $ipffi2";
    flock (FILE2, 2);
    @lignes2 = <FILE2>;
    $nbelemtab2 = $#lignes2+1;
    flock (FILE2, 8);
    close(FILE2);

    open(FILE3, "<$ipffi3") || die "Erreur d'ouverture de $ipffi3";
    flock (FILE3, 2);
    @lignes3 = <FILE3>;
    $nbelemtab3 = $#lignes3+1;
    flock (FILE3, 8);
    close(FILE3);

    open(FILE4, "<$ipffi4") || die "Erreur d'ouverture de $ipffi4";
    flock (FILE4, 2);
    @lignes4 = <FILE4>;
    $nbelemtab4 = $#lignes4+1;
    flock (FILE4, 8);
    close(FILE4);

    open(FILE5, "<$ipffi5") || die "Erreur d'ouverture de $fichier";
    flock (FILE5, 2);
    @lignes5 = <FILE5>;
    $nbelemtab5 = $#lignes5+1;
    flock (FILE5, 8);
    close(FILE5);

    $i = 0;

    $posi = $html->param('ligne');
     
    $rule = &ReadRule($posi, $ipfrules);
    if($posi == 0 || $rule eq 'erreur')
    {
        &Erreur(6);
        return erreur;
    }
    
# Begin of the HTML page
    &entete($posi, $ipfmod);
    @opt = split(/\s+/, $rule);

# We take all the parts of the rule to analyse them
# Exemple : 
# block return-icmp(port-unr) in log level auth.alert quick proto http from 10.23.152.0/32 
# port = 80 to 10.23.156.12/32 port = 80 keep state keep frag 
# Check of the action(pass, block) and if we return something (when the packet is blocked)
    $action = $opt[$i++];
    if($opt[$i] =~/return/)
    {
     $retour = $opt[$i++];
    }
    else 
    {
     $retour = '';
    }
    $action = $action . '-' . $opt[$i++];
    if($opt[$i] eq 'log')
    {
      $i++;
      if($opt[$i] eq 'quick')
      {
        $lopt = 'log';
      }
      elsif($opt[$i] eq 'level')
      {
      	$i++;
        $lopt = 'log level ' . $opt[$i];
        $i++;
      }
      else
      {
        $lopt = 'log ' . $opt[$i];
        $i++;
      }
    }
    else
    {
      $lopt = 'none';
    }
# At this point we are on the 'quick' word
    $i++;
# Check for the interface    
    if($opt[$i] eq 'on')
    {
      $i++;
      $interface = $opt[$i++];
    }
    else
    {
      $interface = 'none';
    }
# Check for the interface    
    if($opt[$i] eq 'proto')
    {
      $i++;
      $proto = $opt[$i++];
    }
    else
    {
      $proto = 'any';
    }
# At this point we are on the 'from' word
    $i++;
    $source = $opt[$i++];
    if($opt[$i] eq 'port')
    {
      $i++;$i++;	# don't forget the egal
      $psource = $opt[$i++];
    }
    else
    {
      $psource = '';
    }
# At this point we are on the 'to' word
    $i++;
    $destination = $opt[$i++];
    if($opt[$i] eq 'port')
    {
      $i++;$i++;	# don't forget the egal
      $pdest = $opt[$i++];
    }
    else
    {
      $pdest = '';
    }
# We keep the value of '$i' to use it later to shows the keep option
    $j = $i;
    
    print << "HTML";
     <TD WIDTH = 450><B> Action : </B></TD>
     <TD WIDTH = 450>
      <SELECT NAME="action" SIZE=3>
HTML
    $i = 0;
    
    while($i < $nbelemtab2-1)
    {
      $xyz = length($lignes2[$i]);
      $lignestmp = substr($lignes2[$i], 0, $xyz-1);
      if($lignestmp eq $action)
      {
        print"<OPTION SELECTED>$lignestmp";
      }
      else
      {
        print"<OPTION>$lignestmp";
      }
      $i++;
    }
    
    if($lignes2[$i] eq $action)
    {
      print"<OPTION SELECTED>$lignes2[$i]";
    }
    else
    {
      print"<OPTION>$lignes2[$i]";
    }
    print << "HTML";
      </SELECT>
     </TD>
HTML

    print << "HTML"; 
     <TD WIDTH = 450><B> Protocol : </B></TD>
     <TD WIDTH = 450>
      <SELECT NAME="service" SIZE=3>
HTML
    $i = 0;
    
    while($i < $nbelemtab-1)
    {
      $xyz = length($lignes[$i]);
      $lignestmp = substr($lignes[$i], 0, $xyz-1);
      if($lignestmp eq $proto)
      {
        print"<OPTION SELECTED>$lignestmp";
      }
      else
      {
        print"<OPTION>$lignestmp";
      }
      $i++;
    }
    
    if($lignes[$i] eq $proto)
    {
      print"<OPTION SELECTED>$lignes[$i]";
    }
    else
    {
      print"<OPTION>$lignes[$i]";
    }
    print << "HTML";
      </SELECT>
     </TD>
HTML

# Line for the layout
    print "</TR><TR>";
    print "<TD WIDTH = 50></TD>";
    print "<TD><B> Source Adress : </B></TD>";

# source adress
    if($source eq 'any')
    {
      print "<TD WIDTH = 450><INPUT TYPE=\"text\" NAME=\"source\" size=30></TD>";
    }    
    else
    {
      print "<TD WIDTH = 450><INPUT TYPE=\"text\" NAME=\"source\" size=30 VALUE = $source></TD>";
    }

# port source
    print "<TD><B> Source Port : </B></TD>";
    if($psource ne '')
    {
        print "<TD><INPUT TYPE=\"text\" NAME=\"psource\" size=5 VALUE = $psource></TP>";
    }
    else
    {
        print "<TD><INPUT TYPE=\"text\" NAME=\"psource\" size=5></TP>";
    }
    
# Layout
    print "</TR><TR>";
    print "<TD WIDTH = 50></TD>";

# destination address
    print "<TD><B> Destination Adress : </B></TD>";
    if($destination eq 'any')
    {
      print "<TD WIDTH = 450><INPUT TYPE=\"text\" NAME=\"destination\" size=30></TD>";
    }    
    else
    {
      print "<TD WIDTH = 450><INPUT TYPE=\"text\" NAME=\"destination\" size=30 VALUE = $destination></TD>";
    }

# port destination
    print "<TD><B> Destination Port : </B></TD>";
    if($pdest ne '')
    {
        print "<TD><INPUT TYPE=\"text\" NAME=\"pdestination\" size=5 VALUE = $pdest></TP>";
    }
    else
    {
        print "<TD><INPUT TYPE=\"text\" NAME=\"pdestination\" size=5></TP>";
    }
    
# Layout
    print "</TR><TR>";
    print "<TD WIDTH = 50></TD>";

# List of possible return (when a packet is blocked)
    print << "HTML"; 
     <TD><B> Reply to blocked packet : </B></TD>
     <TD>
      <SELECT NAME="retour" SIZE=3>
HTML
    $i = 0;
    if($retour eq '')
    {
      $retour = 'none';
    }
    
    while($i < $nbelemtab3-1)
    {
      $xyz = length($lignes3[$i]);
      $lignestmp = substr($lignes3[$i], 0, $xyz-1);
      if($lignestmp eq $retour)
      {
        print"<OPTION SELECTED>$lignestmp";
      }
      else
      {
        print"<OPTION>$lignestmp";
      }
      $i++;
    }
    
    if($lignes3[$i] eq $retour)
    {
      print"<OPTION SELECTED>$lignes3[$i]";
    }
    else
    {
      print"<OPTION>$lignes3[$i]";
    }
    print << "HTML";
        </SELECT>
       </TD>
HTML
    
# Log options  $lopt
    print << "HTML"; 
     <TD><B> Options log : </B></TD>
     <TD>
      <SELECT NAME="logopt" SIZE=3>
HTML
    $i = 0;
#    if($lopt eq '')
#    {
#      $lopt = 'none';
#    }
    
    while($i < $nbelemtab4-1)
    {
      $xyz = length($lignes4[$i]);
      $lignestmp = substr($lignes4[$i], 0, $xyz-1);
      if($lignestmp eq $lopt)
      {
        print"<OPTION SELECTED>$lignestmp";
      }
      else
      {
        print"<OPTION>$lignestmp";
      }
      $i++;
    }
    
    if($lignes4[$i] eq $lopt)
    {
      print"<OPTION SELECTED>$lignes4[$i]";
    }
    else
    {
      print"<OPTION>$lignes4[$i]";
    }
    print << "HTML";
        </SELECT>
       </TD>
HTML
    

# Layout
    print "</TR><TR>";
    print "<TD WIDTH = 50></TD>";

# Verification of the existence of keep statement
# There is one : $opt[$i] is on 'keep'
    $i = $j;
    if($opt[$i++] eq 'keep')
    {
      if($opt[$i++] eq 'state') # 'kstate' is checked
      {
      	print "<TD><B>Keep State</B></TD>";
      	print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kstate\" size=5 CHECKED></TD>";
      	if($opt[$i] eq 'keep') # 'kfrag' is perhaps also checked
      	{
          print "<TD><B>Keep Frag</B></TD>";
      	  print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kfrag\" size=5 CHECKED></TD>";
      	}
      	else
      	{
          print "<TD><B>Keep Frag</B></TD>";
       	  print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kfrag\" size=5></TD>";
      	}
      }
      else # 'kfrag' is checked
      {
        print "<TD><B>Keep State</B></TD>";
      	print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kstate\" size=5></TD>";
        print "<TD><B>Keep Frag</B></TD>";
      	print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kfrag\" size=5 CHECKED></TD>";
      }
      
    }
    else # 'kfrag' is checked
    {
      print "<TD><B>Keep State</B></TD>";
      print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kstate\" size=5></TD>";
      print "<TD><B>Keep Frag</B></TD>";
      print "<TD><INPUT TYPE=\"checkbox\" NAME=\"kfrag\" size=5></TD>";
    }
            
#    print "<TD><B>Log option :</B><INPUT TYPE=\"text\" NAME=\"lopt\" size=30 VALUE=\"$opt[$i]\"></TP>";

# Layout + Interface
    print << "HTML"; 
     </TR><TR>
     <TD WIDTH = 50></TD>
     <TD><B> Interface : </B></TD>
     <TD>
      <SELECT NAME="interface" SIZE=3>
HTML

    $i = 0;
    while($i < $nbelemtab5-1)
    {
      $xyz = length($lignes5[$i]);
      $lignestmp = substr($lignes5[$i], 0, $xyz-1);
      if($lignestmp eq $interface)
      {
        print"<OPTION SELECTED>$lignestmp";
      }
      else
      {
        print"<OPTION>$lignestmp";
      }
      $i++;
    }
    
    if($lignes5[$i] eq $interface)
    {
      print"<OPTION SELECTED>$lignes5[$i]";
    }
    else
    {
      print"<OPTION>$lignes5[$i]";
    }
    print << "HTML";
        </SELECT>
       </TD>
HTML



# Layout
    print"</TR>";





# End of the HTML page
    &finpage();



    
    
    
# This sub routine receive a number (the number of the line where is the rule in the file)
# ans return the rule witch is at the line specified with the number received
# If The number received is to big, we return 'erreur'    
sub ReadRule
{
    my($posi, $fichier) = @_;
    open(FILE, "<$fichier") || die "Erreur d'ouverture de $fichier";
    flock (FILE, 2);
    my(@lignes) = <FILE>;
    my($nbelemtab) = $#lignes+1;
    flock (FILE, 8);
    close(FILE);
    if($nbelemtab >= $posi)
    {
        return $lignes[$posi-1];
    }
    return 'erreur';
}        


# This subroutine is called for created the HTML page
# Content-type, title, FORM, ...
# It put a hidden area (ligne) an create the begin of a table
sub entete
{
    my($posi, $file) = @_;
    print "Content-type:text/html\n\n";
    print << "HTML";
     <html><head><title>IP-Filter rules modification Page</title></head>
<STYLE>
BODY { 
HTML
print"background-image: url($flam); background-repeat: no-repeat;";
print"background: url($flam) right top ;background-repeat: no-repeat;";
        print << "HTML";
}
.test {background: #C41200; color: #FFFFFF}
.submit_button {background: #FE7D19; color: #C41200; font-weight: bold}
</STYLE>
     <BODY TEXT="#FFFFFF" BGCOLOR="#C41200" LINK="#336699" VLINK="#444499" ALINK="#112233">
     <BR>


     <!-- TITLE -->
     <CENTER><P><B><I><U><FONT COLOR="FE7D19"><FONT SIZE=+3>
     Ip-Filter Modification form
     </FONT></FONT></U></I></B></P></CENTER>

     <BR>

     <!-- We'll call the CGI modify.pl when we'll push submit button -->
HTML
     print"<P><FORM METHOD=\"POST\" ACTION=$file>";
    print << "HTML";

     <P><INPUT TYPE="hidden" VALUE="$posi" NAME="ligne"></P>
     <TABLE HEIGHT="250" >
      <TR>
       <TD WIDTH = 50></TD>
HTML
     	
}

# This subroutine is called for finish the HTML page (close TABLE and the tag /HTML, /BODY
# It put the button 'Submit' and finish the FORM
sub finpage
{
    print << "HTML";
    </TR>
     </TABLE>


     <BR><BR>
     <TABLE>
      <TR>
       <TD WIDTH = 50></TD>
       <TD><INPUT TYPE="Submit" VALUE="      Ok      " CLASS=submit_button></TD>
       <TD><INPUT TYPE="Reset"  VALUE="   Cancel   " CLASS=submit_button></TD>
      </TR>
     </TABLE> 

     <!-- End of FORM -->
     <P></FORM></P>
 
     </BODY>
     </HTML>
HTML
}





